;@sa1 <-- DO NOT REMOVE THIS LINE!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Boo ring - SA-1 Compatible version	by 33953YoShI
;
; This sprite is depend on same position tile number.
;
; IMPORTANT NOTE:
; - This sprite is for the exclusive use of Vitor Vilela's SA-1 pack!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Extra Bit			Rotation direction
; Extra Property Byte 1		Number of Boo -1
; Extra Property Byte 2		Space of each Boo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Num, Space, Radius, Speed
Settings:	db $0A,$28,$50,$10	; Tile xxx0
		db $04,$66,$38,$18	; Tile xxx1
		db $05,$55,$40,$14	; Tile xxx2
		db $0A,$28,$50,$10	; Tile xxx3
		
		db $0A,$28,$50,$10	; Tile xxx4
		db $0A,$28,$50,$10	; Tile xxx5
		db $0A,$28,$50,$10	; Tile xxx6
		db $0A,$28,$50,$10	; Tile xxx7
		
		db $0A,$28,$50,$10	; Tile xxx8
		db $0A,$28,$50,$10	; Tile xxx9
		db $0A,$28,$50,$10	; Tile xxxA
		db $0A,$28,$50,$10	; Tile xxxB
		
		db $0A,$28,$50,$10	; Tile xxxC
		db $0A,$28,$50,$10	; Tile xxxD
		db $0A,$28,$50,$10	; Tile xxxE
		db $13,$16,$50,$7F	; Tile xxxF

		!ClockSpeed =	$10
		!CounterClock =	$F0
		!Radius =	$50

		!DispX =	$03
		!DispY =	$03
		!Width =	$0A
		!Height =	$0A

; SA-1 pack - Memory remap
		!BW =		$6000
		
		!9E =		$3200
		!AA =		$9E
		!B6 =		$B6
		!C2 =		$D8
		!D8 =		$3216
		!E4 =		$322C

		!00AA =		$309E
		!00B6 =		$30B6
		!00C2 =		$30D8
		!009E =		$3200
		!00D8 =		$3216
		!00E4 =		$322C
		!14C8 =		$3242
		!14D4 =		$3258
		!14E0 =		$326E
		!151C =		$3284
		!1528 =		$329A
		!1534 =		$32B0
		!1540 =		$32C6
		!154C =		$32DC
		!1558 =		$32F2
		!1564 =		$3308
		!1570 =		$331E
		!157C =		$3334
		!1588 =		$334A
		!1594 =		$3360
		!15A0 =		$3376
		!15AC =		$338C
		!15EA =		$33A2
		!15F6 =		$33B8
		!1602 =		$33CE
		!160E =		$33E4
		!163E =		$33FA
		!187B =		$3410
		
		!14EC =		$74C8
		!14F8 =		$74DE
		!1504 =		$74F4
		!1510 =		$750A
		!15B8 =		$7520
		!15C4 =		$7536
		!15D0 =		$754C
		!15DC =		$7562
		!161A =		$7578
		!1626 =		$758E
		!1632 =		$75A4
		!190F =		$7658
		!1FD6 =		$766E
		!1FE2 =		$7FD6
		!164A =		$75BA
		!1656 =		$75D0
		!1662 =		$75EA
		!166E =		$7600
		!167A =		$7616
		!1686 =		$762C
		!186C =		$7642
		
		!ExtraBits =	$6040
		!ExtraProp1 =	$6057
		!ExtraProp2 =	$606D
		!NewSpriteNum =	$6083
		
		!GetSin =	$07F7DB
		!GetCos =	$07F7DB
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		print "INIT ",pc
		PHB
		PHK
		PLB
		JSR InitCode
		PLB
		RTL

		print "MAIN ",pc
		PHB
		PHK
		PLB
		JSR MainCode
		PLB
		RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InitCode:	LDA !E4,x
		STA $9A
		LDA !14E0,x
		STA $9B
		LDA !D8,x
		STA $98
		LDA !14D4,x
		STA $99
		CLC
		JSR GetBlock
		AND #$0F
		ASL #2
		TAY
		LDA.w Settings+$02,y
		STA !187B,x
		LDA.w Settings,y
		AND #$3F
		STA !ExtraProp1,x
		LDA.w Settings+$01,y
		STA !1602,x
		LDA !ExtraBits,x
		AND #$04
		CMP #$04
		LDA.w Settings+$03,y
		BCC +
		EOR #$FF
		INC A
+		STA !1504,x
		STZ !1510,x
		STZ !151C,x
		STZ !1528,x
		LDA #$00
		STA !ExtraProp2,x
		RTS
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MainCode:	JSR GetDrawInfo
		LDA $9D
		BNE .Start
		LDY #$06
		JSR SubOffScreenSA1
		LDA !1504,x
		TAY
		ASL #4
		CLC
		ADC !1510,x
		STA !1510,x
		TYA
		PHP
		LSR #4
		LDY #$00
		PLP
		BPL .IfPlus
		ORA #$F0
		DEY
.IfPlus		ADC !151C,x
		STA !151C,x
		TYA
		ADC !1528,x
		AND #$01
		STA !1528,x

.Start		STZ $2250
		LDA !151C,x
		STA $0E
		LDA !1528,x
		STA $0F
		LDA !ExtraProp1,x
		AND #$3F
		STA $3110
		STA $0C
		STZ $0D
		LDA !E4,x
		STA $08
		LDA !14E0,x
		STA $09
		LDA !D8,x
		STA $0A
		LDA !14D4,x
		STA $0B
		LDA !1602,x
		STA $00
		STZ $01
		LDA !187B,x
		REP #$30
		AND.w #$00FF
		STA $2251

.PositionLoop	LDA $0E
		CLC
		ADC.w #$0080
		AND.w #$01FF
		TAY
		AND.w #$00FF
		ASL A
		TAX
		LDA.l !GetCos,x
		CPY.w #$0100
		BCC .NotNegCos
		EOR.w #$FFFF
		INC A
.NotNegCos	STA $2253

		LDA $0E
		TAY
		AND.w #$00FF
		ASL A
		TAX

		LDA $2305
		ASL A
		LDA $2307
		ADC $08
		PHA
		LDA.l !GetSin,x
		CPY.w #$0100
		BCC .NotNegSin
		EOR.w #$FFFF
		INC A
		CLC
.NotNegSin	STA $2253

		LDA $0E
		ADC $00
		AND.w #$01FF
		STA $0E

		LDA $2305
		ASL A
		LDA $2307
		ADC $0A
		PHA

		DEC $0C
		BPL .PositionLoop
		SEP #$30
.LoopEnd	LDX $15E9|!BW
		LDA $3110
		STA $0D
		LDY !15C4,x
		BNE +
		STA $0F
		JSR SubGFX
+		LDA $71
		BNE .PullLoop
		LDA $13F9|!BW
		EOR !1632,x
		BEQ .GetCollision
.PullLoop	REP #$20
		LDA $0D
		INC A
		AND.w #$00FF
		ASL #2
		STA $0D
		TSC
		ADC $0D
		TCS
		SEP #$20
		RTS

.GetCollision	LDA #!Width
		STA $06
		LDA #!Height
		STA $07
		JSL $03B664

.CollisionLoop	LDA $0D
		EOR $14
		LSR A
		BCC .PullNext
		LDA $94
		SBC $03,s
		CLC
		ADC #$20
		CMP #$40
		BCS .PullNext
		LDA $96
		ADC #$18
		SEC
		SBC $01,s
		CMP #$60
		BCS .PullNext
		PLA
		PLY
		ADC #!DispY
		STA $05
		BCC +
		INY
		CLC
+		STY $0B
		PLA
		PLY
		ADC #!DispX
		STA $04
		BCC +
		INY
+		STY $0A
		JSL $03B72B
		BCC .Next
		LDA $1497|!BW
		ORA $1490|!BW
		BNE .Next
		LDA $187A|!BW
		BEQ +
		JSR LoseYoshi
		BRA .Next
+		JSL $00F5B7
		BRA .Next
.PullNext	PLA
		PLA
		PLA
		PLA
.Next		DEC $0D
		BPL .CollisionLoop
		RTS

LoseYoshi:	LDX $18E2|!BW
		DEX
		BMI +
		LDA #$10
		STA !163E,x
		LDA #$03
		STA $1DFA|!BW
		LDA #$13
		STA $1DFC|!BW
		LDA #$02
		STA !C2,x
		STZ $187A|!BW
		STZ $0DC1|!BW
		LDA #$C0
		STA $7D
		STZ $7B
		LDY !157C,x
		LDA .SetXspeed,y
		STA !B6,x
		STZ !1594,x
		STZ !151C,x
		STZ $18AE|!BW
		LDA #$30
		STA $1497|!BW
+		LDX $15E9|!BW
		RTS

.SetXspeed	db $20,$E0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TileMap:	db $AE,$AA
		db $8C,$88
		db $8C,$88
		db $8E,$A8

SubGFX:		LDA $14			;\
		LSR #3			; | $05 : TileMap base (#$00 or #$01)
		AND #$01		; |
		STA $05			;/
		LDA !15F6,x		;\
		ORA $64			; | $04 : TileProp
		EOR #$40		; |
		STA $04			;/
		LDA !15EA,x		;\ $06 : OAMindex
		STA $06			;/
		LSR #2			;\
		ADC #$60		; |
		STA $02			; | $02,$03 : #$6460+(OAMindex>>2)
		LDA #$64		; |
		STA $03			;/
		TSX

.Loop		REP #$21
		LDA $3703,x		;\
		ADC.w #$000F		; |
		SEC			; | if SpriteY-ScreenY isn't between -#$000F to #$00DF,
		SBC $1C			; | drawing will be skipped.
		CMP.w #$00EF		; |
		BCS .Next		;/
		STA $00			; $00,$01 : OAM Ypos+#$0F
		LDA $3705,x		;\
		ADC.w #$000F		; |
		SEC			; | if SpriteX-ScreenX ins't between -#$000F to #$00FF,
		SBC $1A			; | drawing will be skipped.
		CMP.w #$010F		; |
		BCS .Next		;/
		SBC.w #$000E		; A : OAM Xpos
		SEP #$21		;
		XBA			;\ 
		AND #$01		; |
		ORA #$02		; | write OAM highbyte
		STA ($02)		; |
		INC $02			;/
		LDY $05			;
		LDA.w TileMap,y		;
		LDY $06			;
		STA $0302|!BW,y		;
		LDA $04			;
		STA $0303|!BW,y		;
		LDA $00			;\ A : OAM Ypos
		SBC #$0F		;/
		REP #$21		;\
		XBA			; | write OAM Xpos and Ypos
		STA $0300|!BW,y		;/
		TYA			;\
		ADC.w #$0004		; | OAMindex += 4
		STA $06			;/
.Next		SEP #$21		;
		TXA			;\
		ADC #$03		; | X += 4
		TAX			;/
		LDA $05			;
		ADC #$02		;
		AND #$07		;
		STA $05			;
		DEC $0F			;
		BPL .Loop		;
		LDX $15E9|!BW		;
		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetDrawInfo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; DON'T REPLACE TO SHARED ROUTINE.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetDrawInfo:	LDA !E4,x
		CMP $1A
		LDA !14E0,x
		SBC $1B
		BEQ .OnScreenX
		LDA #$01
.OnScreenX	STA !15A0,x

		LDA !14E0,x
		PHA
		LDA !E4,x
		PHA
		LDY !187B,x
		REP #$20
		TYA
		STA $00
		ASL A
		ADC.w #$0110
		STA $02
		PLA
		ADC $00
		CLC
		ADC.w #$0010
		SEC
		SBC $1A
		CMP $02
		SEP #$20
		TDC
		ROL A
		STA !15C4,x
		BNE .Invalid

		LDA !14D4,x
		XBA
		LDA !D8,x
		REP #$21
		ADC.w #$000C
		SEC
		SBC $1C
		SEP #$20
		XBA
		BEQ .OnScreenY
		LDA #$01
.OnScreenY	STA !186C,x
.Invalid	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubOffScreenSA1:
		LDA !15A0,x
		ORA !186C,x
		BEQ .Return2
		LDA !167A,x
		AND #$04
		BNE .Return2
		LDA $5B
		LSR A
		BCS .VerticalLevel
		LDA !D8,x
		ADC #$50
		LDA !14D4,x
		ADC #$00
		CMP #$02
		BCS .EraseSprite
		LDA !14E0,x
		XBA
		LDA !E4,x
		REP #$21
		ADC .AddTable,y
		SEC
		SBC $1A
		CMP .CmpTable,y
.Common		SEP #$20
		BCC .Return2
.EraseSprite	LDA !14C8,x
		CMP #$08
		BCC .KillSprite
		LDY !161A,x
		CPY #$FF
		BEQ .KillSprite
		TYX
		LDA.l $418A00,x
		AND #$FE
		STA.l $418A00,x
		LDX $15E9|!BW
.KillSprite	STZ !14C8,x
.Return2	RTS

.VerticalLevel	LDA $13
		LSR A
		BCS .CheckY
		LDA !14E0,x
		XBA
		LDA !E4,x
		REP #$21
		ADC.w #$0040
		CMP.w #$0280
		BRA .Common
.CheckY		LDA !14D4,x
		XBA
		LDA !D8,x
		REP #$20
		SBC $1C
		CLC
		ADC.w #$0070
		CMP.w #$01D0
		BRA .Common

.AddTable	dw $0040,$0040,$0010,$0070
		dw $0090,$0050,$0080,$FFC0
.CmpTable	dw $0170,$01E0,$01B0,$01D0
		dw $0230,$01B0,$0220,$0160
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetBlock:	BCC .Layer1
		LDA $5B
		BPL .Layer1
		LSR A
		BCC .Horz0
		LDA $99
		ADC #$0D
		STA $99
		BRA .Common0
.Horz0		LDA $9B
		ADC #$10
		STA $9B
.Common0	REP #$21
		LDA $9A
		ADC $26
		STA $9A
		LDA $98
		CLC
		ADC $28
		STA $98
		SEP #$20
.Layer1		JSR .GetBlockAddr
		LDA [$00]
		TAY
		DEC $02
		LDA [$00]
		STA $1693|!BW
		RTS

.GetBlockAddr	LDA $9A
		LSR #4
		STA $00
		LDA $98
		AND #$F0
		ORA $00
		STA $00
		STZ $02
		LDA $5B
		LSR A
		LDA $99
		BCC .HorzLevel
		ASL A
		STA $03
		LDA $9B
		STA $01
		REP #$21
		LDA.w #$0000
		BRA .Common
.HorzLevel	STA $03
		STZ $01
		STZ $2250
		LDA $9B
		ASL A
		STA $2251
		STZ $2252
		LDA #$D8
		STA $2253
		STZ $2254
		REP #$21
		NOP
		LDA $2306
.Common		ADC $02
		ADC $00
		ADC.w #$C800
		STA $00
		SEP #$20
		LDA #$41
		STA $02
		RTS
		